---
-- AnimatedObjectExtend
--
-- 
--
-- Copyright (c) DerElky, 2019


function load(self, superFunc, nodeId, xmlFile, key, xmlFilename)
	local success = superFunc(self, nodeId, xmlFile, key, xmlFilename)
    local autoopenkey = key .. ".autoOpen"
    self.autoopen= Utils.getNoNil(getXMLBool(xmlFile, autoopenkey.."#use"), false)
	self.objectcount = 0
	self.lockdoor = false
	--self.LockdoorText = g_i18n:getText("LockdoorText")
	self.Lockdoorenable = g_i18n:getText("Lockdoorenable")
	self.Lockdoordisable = g_i18n:getText("Lockdoordisable")
	--local changetriggerId = I3DUtil.indexToObject(nodeId, getXMLString(xmlFile, key..".controls#triggerNode"))
	if self.controls.triggerId ~= nil then
		setCollisionMask(self.controls.triggerId, 1056768)
	end
	
	
	return success
end

function AnimatedObject:autoOpen(objectcount,lockdoor,noEventSend)
	if self.isServer then
		self.objectcount = objectcount
		self.lockdoor = lockdoor
		if (self.objectcount > 0 ) then
			if self.animation.time ~= 1 then
				self.animation.direction = 1
			end
		else
			if self.animation.time ~= 0 then
				self.animation.direction = -1
			end
		end
        self:raiseActive()
	end
	sendtriggervalues.sendEvent(self, self.objectcount, self.lockdoor,noEventSend)
end


function AnimatedObject:addRemoveInputsAutoopen()
	 	
		if self.eventId == nil then
			local _, eventId = g_inputBinding:registerActionEvent(InputAction.LOCK_DOOR, self, self.onActivateObjectautopen, false, true, false, true);
			self.eventId = eventId;
			self:changetext();
		else
			g_inputBinding:removeActionEvent(self.eventId);
			self.eventId = nil;
		end;
	
end;

function AnimatedObject:onActivateObjectautopen()
		
	if self.autoopen then 	
		if self.lockdoor then
			self.lockdoor = false
		else
			self.lockdoor = true
			self.objectcount = 0
			sendtriggervalues.sendEvent(self, self.objectcount,self.lockdoor, noEventSend)
			
		end
	self:changetext()
	end
	
	self:raiseActive()	
end;

function AnimatedObject:changetext()
local Lockdoorstate = self.Lockdoordisable
	if self.eventId == nil then
	else
		if self.lockdoor then
			Lockdoorstate = self.Lockdoordisable
		else
			Lockdoorstate = self.Lockdoorenable
		end
		g_inputBinding:setActionEventText(self.eventId, Lockdoorstate)
	end	
end;

function saveToXMLFile(self, xmlFile, key, usedModNames)

    setXMLBool(xmlFile, key.."#lockstate", self.lockdoor)
end;

function loadFromXMLFile(self, superFunc, xmlFile, key)

	 self.lockdoor = Utils.getNoNil(getXMLBool(xmlFile, key.."#lockstate"), false)
	 superFunc(self, xmlFile, key)
	 return true
end;


function triggerCallback(self, superfunc, triggerId, otherId, onEnter, onLeave, onStay, anotherID)   
	

		local vehicle = g_currentMission.nodeToObject[otherId]
		local pvehicle = false
		local vehiclecanaccess = false
		if vehicle ~= nil then			
			if vehicle.vehicleType ~= nil then
				pvehicle = true
				if vehicle:getActiveFarm() ~= nil then
					vehiclecanaccess = g_currentMission.accessHandler:canFarmAccessOtherId(vehicle:getActiveFarm(), self.ownerFarmId)
				else
					vehiclecanaccess = false
				end
			end
		end
		local oldobjectcount = self.objectcount
		local useauto = false
		if self.autoopen then
			if self.openingHours ~=nil then
				if self.openingHours.isOpen then
					useauto = true
				else
					useauto = false
				end
			else
				useauto = true
			end
		end
		if onEnter or onLeave then
				if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
					if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode and self.autoopen then
				
						self:addRemoveInputsAutoopen()
					end
					if onEnter then
						if self.ownerFarmId == nil or self.ownerFarmId == AccessHandler.EVERYONE or g_currentMission.accessHandler:canFarmAccessOtherId(g_currentMission:getFarmId(), self.ownerFarmId) then
							
							self.playerInRange = true
						end
					else 	
						self.playerInRange = nil
					end				
					self:raiseActive()	
				else
					if pvehicle and not self.lockdoor then
						if self.ownerFarmId == nil or self.ownerFarmId == AccessHandler.EVERYONE or vehiclecanaccess then
							if onEnter then
								if useauto then
									self.objectcount = self.objectcount + 1
								end
							else 
								if useauto then
									self.objectcount = math.max(self.objectcount - 1, 0) 
								end
							end			
						end
					end
				end
			
		
			if useauto and oldobjectcount ~= self.objectcount and not self.lockdoor then
				self:autoOpen(self.objectcount,self.lockdoor)							
			end
		end
end

function readStream(aniobj, streamId, connection)
     if connection:getIsServer() then
		aniobj.objectcount = streamReadUInt8(streamId)
		aniobj.lockdoor = streamReadBool(streamId)
    end
end

function writeStream(aniobj, streamId, connection)
    if not connection:getIsServer() then
		streamWriteUInt8(streamId, aniobj.objectcount)
		streamWriteBool(streamId, aniobj.lockdoor)
    end
end

sendtriggervalues = {}
local sendtriggervalues_mt = Class(sendtriggervalues, Event)

InitEventClass(sendtriggervalues, "sendtriggervalues")

function sendtriggervalues:emptyNew()
    local self = Event:new(sendtriggervalues_mt)
    return self
end

function sendtriggervalues:new(aniobj, objectcount,lockdoor)
    local self = sendtriggervalues:emptyNew()
    self.aniobj = aniobj
	self.objectcount = objectcount
	self.lockdoor = lockdoor
    return self
end

function sendtriggervalues:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.aniobj)
	streamWriteUInt8(streamId, self.objectcount)
	streamWriteBool(streamId, self.lockdoor)
end

function sendtriggervalues:readStream(streamId, connection)
	self.aniobj = NetworkUtil.readNodeObject(streamId)
	self.objectcount = streamReadUInt8(streamId)
	self.lockdoor = streamReadBool(streamId)
    self:run(connection)
end

function sendtriggervalues:run(connection)
	self.aniobj:autoOpen(self.objectcount,self.lockdoor,true)
	
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, nil, connection, self.aniobj)
    end
end

function sendtriggervalues.sendEvent(aniobj,objectcount,lockdoor, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(sendtriggervalues:new(aniobj, objectcount,lockdoor), nil, nil, aniobj)
		else
			g_client:getServerConnection():sendEvent(sendtriggervalues:new(aniobj,objectcount,lockdoor))
		end
	end
end



	
AnimatedObject.load = Utils.overwrittenFunction(AnimatedObject.load, load)
AnimatedObject.readStream = Utils.appendedFunction(AnimatedObject.readStream, readStream)
--AnimatedObject.update = Utils.prependedFunction(AnimatedObject.update, update)
AnimatedObject.writeStream = Utils.appendedFunction(AnimatedObject.writeStream, writeStream)
AnimatedObject.triggerCallback = Utils.overwrittenFunction(AnimatedObject.triggerCallback, triggerCallback)
AnimatedObject.saveToXMLFile = Utils.appendedFunction(AnimatedObject.saveToXMLFile, saveToXMLFile)
AnimatedObject.loadFromXMLFile = Utils.overwrittenFunction(AnimatedObject.loadFromXMLFile, loadFromXMLFile)
